#ifndef WIN32
#include <unistd.h>
#endif
#include <qapplication.h>
#include <qlabel.h>
#include <qfont.h>
#include <qwindowsstyle.h>
#include <qplatinumstyle.h> 
#include <qmotifstyle.h>
#include <qcdestyle.h>
#include <qtranslator.h>
#include <qobject.h>

#include <stdlib.h>
#include <sys/types.h>
#include <sys/stat.h>

#include "mainwindow.h"
#include "resource.h"
#include "mdiwindow.h"
#include "config.h"

void hide_argv(char *);

int main(int argc,char **argv)
{
	QApplication app(argc,argv);

	bool flag = FALSE;

	QString host;
	QString user;
	QString password;
	int port = 3306;
	QString database;
	QString socket;

	if(argc > 2)
	{
		for(int z = 1; z < argc; z++)
		{
			if(argv[z][0] != '-')
				continue;
			
			switch(argv[z][1])
			{
				case 'h':
					host = argv[z + 1];
					hide_argv(argv[z + 1]);
					z++;
					break;
				case 'u':
					user = argv[z + 1];
					hide_argv(argv[z + 1]);
					z++;
					break;
				case 'p':
					password = argv[z + 1];
					hide_argv(argv[z + 1]);
					z++;
					break;
				case 'd':
					database = argv[z + 1];
					hide_argv(argv[z + 1]);
					z++;
					break;
				case 'P':
					port = atoi(argv[z + 1]);
					hide_argv(argv[z + 1]);
					z++;
					break;
				case 's':
					socket = argv[z + 1];
					hide_argv(argv[z + 1]);
					z++;
					break;
			}
		}

		if(!host.isEmpty() && !user.isEmpty())
			flag = TRUE;
	}

	app.setStyle(new QWindowsStyle());

#ifndef WIN32
	app.setFont(QFont("lucida", 10));
#else
	app.setFont(QFont(QString::fromLocal8Bit("޸ڼü"), 8));
#endif

#ifndef WIN32
	umask(077);
#endif

	MainWindow *mysql = new MainWindow;

	mysql->setCaption(QObject::tr("MySQL Navigator ") + VERSION);

	app.setMainWidget(mysql);

	mysql->show();
	
	if(flag)
		mysql->connect_directly(host, user, password, database, port, socket);
	else
		mysql->slot_connect();

	return  app.exec();
}

void hide_argv(char *value)
{
	for(unsigned int z = 0; z < strlen(value); z++)
		value[z] = '*';
}
