#include "option.h"

#include <qlineedit.h>
#include <qcheckbox.h>
#include <qpushbutton.h>
#include <qspinbox.h>
#include <qmessagebox.h>

void Option::signal_connect()
{
	connect((const QObject *)fire, SIGNAL(clicked()), (const QObject *)this, SLOT(slot_fire()));
	connect((const QObject *)close, SIGNAL(clicked()), (const QObject *)this, SLOT(slot_close()));
	connect((const QObject *)apply, SIGNAL(clicked()), (const QObject *)this, SLOT(slot_apply()));
	connect((const QObject *)image_button, SIGNAL(clicked()), (const QObject *)this, SLOT(slot_image_file()));
	connect((const QObject *)image_flag, SIGNAL(clicked()), (const QObject *)this, SLOT(slot_image_flag()));
	connect((const QObject *)password_flag, SIGNAL(clicked()), (const QObject *)this, SLOT(slot_password_flag()));
	connect((const QObject *)schema_flag, SIGNAL(clicked()), (const QObject *)this, SLOT(slot_schema_flag()));
	connect((const QObject *)process_flag, SIGNAL(clicked()), (const QObject *)this, SLOT(slot_process_flag()));
}

void Option::slot_flag(struct __option__ *option)
{
	this->option = option;

	image_flag->setChecked(option->image.flag);
	image_file->setText(option->image.file);

	if(option->image.flag == FALSE)
	{
		image_file->setEnabled(FALSE);
		image_button->setEnabled(FALSE);
	}

	schema_flag->setChecked(option->schema.flag);
	password_flag->setChecked(option->password.flag);

	exit_flag->setChecked(option->exit.flag);

	from->lineEdit()->setText(QString::number(option->from));
	to->lineEdit()->setText(QString::number(option->to));
	
	process_value->setValue(option->process.value);
	process_flag->setChecked(option->process.flag);

	if(option->process.flag == FALSE)
		process_value->setEnabled(FALSE);

	history->setChecked(option->clear);

	save->setChecked(option->save);

	log->setChecked(option->log);
}
