#include "option.h"

#include <qfiledialog.h>
#include <qcheckbox.h>
#include <qspinbox.h>
#include <qpushbutton.h>

void Option::slot_fire()
{
	slot_apply();

	parentWidget()->close();
}

void Option::slot_apply()
{
	option->schema.flag = schema_flag->isChecked();
	option->password.flag = password_flag->isChecked();

	option->exit.flag = exit_flag->isChecked();
	
	option->image.flag = image_flag->isChecked();
	option->image.file = image_file->text();
	
	option->from = from->currentText().toInt();
	option->to = to->currentText().toInt();
	
	option->process.flag = process_flag->isChecked();
	option->process.value = process_value->text().toInt();

	option->clear = history->isChecked();

	option->save = save->isChecked();

	option->log = log->isChecked();

	emit signal_image();
}


void Option::slot_close()
{
	parentWidget()->close();
}

void Option::slot_image_file()
{
	QString s = QFileDialog::getOpenFileName(QString::null, "*.xpm; *.png", this);

	if(!s.isEmpty())
	{
		image_file->setText(s);
	}
}

void Option::slot_image_flag()
{
	if(image_flag->isChecked())
	{
		image_file->setEnabled(TRUE);
		image_button->setEnabled(TRUE);
	}
	else
	{
		image_file->setEnabled(FALSE);
		image_button->setEnabled(FALSE);
	}
}

void Option::slot_password_flag()
{
}

void Option::slot_schema_flag()
{
}

void Option::slot_process_flag()
{
	if(process_flag->isChecked())
	{
		process_value->setEnabled(TRUE);
	}
	else
	{
		process_value->setEnabled(FALSE);
	}
}
