#include "query.h"

#include <qbuttongroup.h>
#include <qdom.h>
#include <qfile.h>
#include <stdlib.h>
#include "mainwindow.h"

void Query::signal_connect()
{
	connect(history, SIGNAL(activated(const QString &)), this, SLOT(slot_sql(const QString &)));
	connect(parentWidget(), SIGNAL(signal_close()), this, SLOT(slot_close()));
	connect((const QObject *)qApp->mainWidget(), SIGNAL(signal_database()), this, SLOT(slot_database()));
}

void Query::resizeEvent(QResizeEvent *)
{
}

void Query::closeEvent(QCloseEvent *)
{
}

bool Query::is_exist_in_history(const QString &sql)
{
	for(int z = 0; z < history->count(); z++)
		if(history->text(z) == sql)
			return TRUE;

	return FALSE;
}

bool Query::save_sql()
{
	QDomElement value;
	QDomElement s;
	QDomDocument z("mysql");

	// document element
	z.appendChild(z.createElement("mysql"));	

	// query
	for(int _s = 0; _s < history->count(); _s++)
	{
		z.documentElement().appendChild(value = z.createElement("query"));
		value.appendChild(s = z.createElement("name"));
		s.appendChild(z.createTextNode(history->text(_s)));

		value.appendChild(s = z.createElement("database"));
		s.appendChild(z.createTextNode(sql_map.find(history->text(_s)).data().database));
		
		value.appendChild(s = z.createElement("sql"));
		s.appendChild(z.createTextNode(sql_map.find(history->text(_s)).data().sql));
	}

	char buffer[255];

#ifndef WIN32
	sprintf(buffer, "%s/%s", getenv("HOME"), ".mysqlnavigator.sql");
#else
	sprintf(buffer, "%s/%s", "c:", ".mysqlnavigator.sql");
#endif

	QFile xml(buffer);

	if(xml.open(IO_WriteOnly) == FALSE)
		return FALSE;

	xml.writeBlock(z.toString(), z.toString().length());

	xml.close();

	return TRUE;
}

bool Query::load_sql()
{
	char buffer[255];

#ifndef WIN32
	sprintf(buffer, "%s/%s", getenv("HOME"), ".mysqlnavigator.sql");
#else
	sprintf(buffer, "%s/%s", "c:", ".mysqlnavigator.sql");
#endif

	QFile xml(buffer);

	if(xml.open(IO_ReadOnly) == FALSE)
		return FALSE;

	QDomDocument document("mysql");

	if(document.setContent(&xml) == FALSE)
	{
		xml.close();
		return FALSE;
	}

	xml.close();

	QDomNodeList sql;

	sql = document.elementsByTagName("query");

	for(unsigned int s = 0; s < sql.count(); s++)
	{
		QString name;
		struct sql_data data;

		name = sql.item(s).firstChild().firstChild().nodeValue();
		history->insertItem(name);

		data.database = sql.item(s).firstChild().nextSibling().firstChild().nodeValue();
		data.sql = sql.item(s).lastChild().firstChild().nodeValue();

		sql_map.insert(name, data);
	}

	return TRUE;
}
