#include "server.h"
#include "servernew.h"
#include <qpopupmenu.h>
#include <qlistview.h>
#include <qmessagebox.h>
#include <qfiledialog.h>
#include <qpopupmenu.h>
#include <qmenubar.h>
#include <qstatusbar.h>
#include <stdlib.h>
#include "database.xpm"

void Server::slot_server(QListViewItem *data, const QPoint &, int)
{
	if(data == NULL)
		return;

	QPopupMenu *z;

	if(data->parent() == NULL)
	{

		z = new QPopupMenu;
		z->insertItem(tr("&New"), this, SLOT(slot_server_new(int)));

		z->popup(QCursor::pos());

		needle = data;
	}
	else
	{
		z = new QPopupMenu;
		z->insertItem(tr("&Open"), this, SLOT(slot_server_open(int)));
		z->insertSeparator();	
		z->insertItem(tr("&Modify"), this, SLOT(slot_server_modify(int)));
		z->insertItem(tr("&Delete"), this, SLOT(slot_server_delete(int)));

		z->popup(QCursor::pos());

		needle = data;
	}
}

void Server::slot_server_new(int)
{
	ServerNew *server = new ServerNew(this, 0, TRUE);

	server->setCaption(tr("New Server"));

	server->exec();

	if(server->flag)
	{
		QListViewItemIterator sql(this->server);

		for(; sql.current(); sql++)
		{
			if(sql.current()->text(0) == server->user->text() + "@" + server->host->text())
			{
				QMessageBox::critical(this, tr("MySQL Navigator"), sql.current()->text(0) + tr(" already exists"));
				return;
			}
		}

		struct server_data data;

		data.user = server->user->text();
		data.password = server->password->text();
		data.database = server->database->text();
		data.port = server->port->text();
		data.socket = server->socket->text();
	
		((MainWindow *)qApp->mainWidget())->server_map.insert(data.user + "@" + server->host->text(), data);
	
		QListViewItem *s = new QListViewItem(this->server->firstChild(), data.user + "@" + server->host->text());	
		s->setPixmap(0, QPixmap(database_xpm));
	}
	
	statusBar()->message(QString(tr(" Servers: ") + QString::number(this->server->firstChild()->childCount())));
}

void Server::slot_server_modify(int)
{
	needle = server->selectedItem();

	if(needle == NULL)
		return;

	if(needle == server->firstChild())
		return;

	struct server_data data = ((MainWindow *)qApp->mainWidget())->server_map.find(needle->text(0)).data();

	ServerNew *server = new ServerNew(this, 0, TRUE);
	
	server->setCaption(tr("Modify Server"));

	server->host->setText(((MainWindow *)qApp->mainWidget())->get_server(needle->text(0)));
	server->user->setText(data.user);
	server->password->setText(data.password);
	server->database->setText(data.database);
	server->port->setText(data.port);
	server->socket->setText(data.socket);

	server->exec();
	
	if(server->flag)
	{
		QListViewItemIterator sql(this->server);

		for(; sql.current(); sql++)
		{
			if(sql.current() == needle)
				continue;

			if(sql.current()->text(0) == server->user->text() + "@" + server->host->text())
			{
				QMessageBox::critical(this, tr("MySQL Navigator"), sql.current()->text(0) + tr(" already exists"));
				return;
			}
		}

		struct server_data data;

		data.user = server->user->text();
		data.password = server->password->text();
		data.database = server->database->text();
		data.port = server->port->text();
		data.socket = server->socket->text();

		((MainWindow *)qApp->mainWidget())->server_map.remove(needle->text(0));
		((MainWindow *)qApp->mainWidget())->server_map.insert(data.user + "@" + server->host->text(), data);
	
		needle->setText(0, data.user + "@" + server->host->text());	
	}
}

void Server::slot_server_delete(int)
{
	needle = server->selectedItem();

	if(needle == NULL)
		return;

	if(needle == server->firstChild())
		return;

	if(QMessageBox::warning (this, tr("MySQL Navigator"), tr("Are you sure you want to delete ") + needle->text(0) + " server ?", tr("Yes"), tr("No")) == 1)
		return;

	((MainWindow *)qApp->mainWidget())->server_map.remove(needle->text(0));

	delete needle;
	
	statusBar()->message(QString(tr(" Servers: ") + QString::number(this->server->firstChild()->childCount())));
}

void Server::slot_server_open()
{
	slot_server_open(TRUE);
}

void Server::slot_server_open(int)
{
	needle = server->selectedItem();

	if(needle == NULL)
		return;

	if(needle == server->firstChild())
		return;

	struct server_data data = ((MainWindow *)qApp->mainWidget())->server_map.find(needle->text(0)).data();

	if(flag)
	{
		QString sql;

#ifdef WIN32
		sql += "mysqlnavigator.exe ";
#else
		sql += "mysqlnavigator ";
#endif

		sql += "-h " + ((MainWindow *)qApp->mainWidget())->get_server(needle->text(0)) + " ";

		sql += "-u " + data.user + " ";				

		if(data.password.isEmpty() == FALSE)
			sql += "-p " + data.password + " ";				

		if(data.database.isEmpty() == FALSE)
			sql += "-d " + data.database + " ";				

		if(data.port.isEmpty() == FALSE)
			sql += "-P " + data.port + " ";				

		if(data.socket.isEmpty() == FALSE)
			sql += "-s " + data.socket + " ";				

#ifdef WIN32
		::WinExec(sql.latin1(), SW_SHOW);
#else
		sql += "&";
		system(sql.latin1());
#endif
	
		QMainWindow::close();

		return;
	}	
	
	if(!mysql_real_connect(&((MainWindow *)qApp->mainWidget())->mysql,
							((MainWindow *)qApp->mainWidget())->get_server(needle->text(0)).latin1(),
							data.user.latin1(),
							data.password.latin1(),
							data.database.length()==0?NULL:data.database.latin1(),
							data.port.length()==0?3306:data.port.toUInt(),
							data.socket.length()==0?NULL:data.socket.latin1(),
							0	
							))
	{
		QMessageBox::critical(this, tr("MySQL Navigator"), QString::fromLocal8Bit(mysql_error(&((MainWindow *)qApp->mainWidget())->mysql)));
	}
	else
	{
		emit signal_server(needle->text(0), data.user);

		QMainWindow::close();
	}
}

bool Server::initialize()
{
	QPopupMenu *z;

	z = new QPopupMenu;
	z->insertItem(tr("&New"), this, SLOT(slot_server_new(int)), CTRL+Key_N);
	z->insertItem(tr("&Open"), this, SLOT(slot_server_open(int)), CTRL+Key_O);
	z->insertSeparator();	
	z->insertItem(tr("Cl&ose"), this, SLOT(slot_close()));
	
	menuBar()->insertItem(tr("&File"),z);
	
	z = new QPopupMenu;
	z->insertItem(tr("&Modify"), this, SLOT(slot_server_modify(int)), CTRL+Key_M);
	z->insertItem(tr("&Delete"), this, SLOT(slot_server_delete(int)), CTRL+Key_D);
	menuBar()->insertItem(tr("&Edit"), z);
	
	z = new QPopupMenu;
	z->insertItem(tr("&About..."), this, SLOT(slot_about()), Key_F1);
	menuBar()->insertItem(tr("&Help"), z);

	statusBar();

	QMap<QString, struct server_data>::Iterator server;

	for(server = ((MainWindow *)qApp->mainWidget())->server_map.begin(); server != ((MainWindow *)qApp->mainWidget())->server_map.end(); server++)
	{
		QListViewItem *s = new QListViewItem(this->server->firstChild(), server.key());	
		s->setPixmap(0, QPixmap(database_xpm));
	}

	statusBar()->message(QString(tr(" Servers: ") + QString::number(this->server->firstChild()->childCount())));
	
	return TRUE;
}

void Server::slot_about()
{
	QMessageBox::information(this, tr("MySQL Navigator"), "This is Server"); 
}

void Server::slot_close()
{
	QMainWindow::close();
}
